''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.


#ifndef JM_FONT_CHAR_T
''#ifndef JM_FONT_CHAR_T_DEFINED
''#define JM_FONT_CHAR_T_DEFINED
Type JM_FONT_CHAR_T as integer
#endif


#define JM_FONT_PTR_DEFINED
Type JM_FONT_PTR as JM_FONT_T Ptr
Type JM_FONT_T
	typ as integer                   '' = JM_FONT_TYPES
	w as integer
	h as integer
	bpchar as integer			     '' bytes per char
	chardata as JM_FONT_CHAR_T ptr   '' pointer to char data
	bpglyph as integer               '' bytes per glyph
	glyphdata as any ptr			 '' pointer to glyph data
	handle as integer
	pfnDelete as Sub(byval fnt As JM_FONT_PTR)
	GetCharAdvanceX as function(byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	GetCharAdvanceY as function(byval fnt As JM_FONT_PTR, byval ch as integer) As Integer
	DrawChar as function(byval fnt As JM_FONT_PTR, ByVal x as Integer, ByVal y as Integer, ByVal ch as Integer, ByVal foreColor as Integer, ByVal backColor as Integer, ByVal trans as integer) as integer
End Type
