''  jm_boxes_color.bas - jm_gui
''	Copyright (C) 2005-2007 Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.
''

''#define UI_SYSCLR_FRAME_FACE    = 1
''#define UI_SYSCLR_FRAME_HIGH    = 2
''#define UI_SYSCLR_FRAME_SHADOW  = 3
''#define UI_SYSCLR_FRAME_OUTLINE = 4
''#define UI_SYSCLR_TEXT          = 5
''#define UI_STSCLR_TEXT_BACK     = 6

Dim Shared SysColor8(0 to 7) as integer  = { 0, 7, 15, 0, 0, 15, 15, 0 }

Dim Shared SysColor24(0 to 7)  as uinteger = { RGB(0,0,0), _
									RGB(127,127,191), _
									RGB(255,255,255), _
									RGB(0,0,0), _
									RGB(0,0,0), _
									RGB(255,255,255), _
									RGB(0,0,0), _
									RGB(0,0,0) }

dim shared sysColors as integer ptr

dim shared palettebuffer(0 to 255) as integer
dim shared _bitdepth as integer

private sub jm_boxes_color_init alias "jm_boxes_color_init" () constructor
	sysColors = @SysColor24(0)
	_bitdepth = 8
end sub

Sub UI_SetColorDepth alias "UI_SetColorDepth" (byval bitdepth as integer)
	dim i as integer
	select case bitdepth
	case 8
		sysColors = @SysColor8(0)
		for i = 0 to 7
	  		''palette SysColor8(i), SysColor24(i) 
		next i
	case else																																		 
		sysColors = @SysColor24(0)
	end select

	_bitdepth = bitdepth

end sub

function UI_GetColorDepth alias "UI_GetColorDepth" () as integer
	function = _bitdepth
end function

Function UI_GetSysColor alias "UI_GetSysColor" (byval index as integer) as integer
	if sysColors then
		function = sysColors[index and 7]
	endif
End Function

Sub UI_SetSysColor alias "UI_SetSysColor" (byval index as integer, byval clr as integer)
	if sysColors then
		sysColors[index and 7] = clr
	endif
End sub
