#ifndef __INCLUDE_CON_BUF_BI__
#define __INCLUDE_CON_BUF_BI__


''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.






type CONBUFFER_T
  As Integer maxrow      '' max rows
  As Integer maxcol      '' max columns
  As Integer row         '' current row
  As Integer col         '' current col
  As Integer size        '' size of console in bytes
  As Integer changed     '' set to TRUE if changed
  AS UByte Ptr dataptr   '' pointer to console data
end type

Declare Sub conbuf_clear alias "conbuf_clear" ( ByVal conbuffer As CONBUFFER_T Ptr )
Declare Sub conbuf_text alias "conbuf_text" ( ByVal conbuffer As CONBUFFER_T Ptr, ByVal txt As UByte ptr )
Declare Function conbuf_resize alias "conbuf_resize" ( ByVal conbuffer As CONBUFFER_T Ptr, ByVal rows As Integer, Byval cols As Integer) as integer

#endif
