#ifndef __INCLUDE_JM_GUI_RT_BI__
#define __INCLUDE_JM_GUI_RT_BI__

''  Copyright (C) 2005-2007, Jeff Marshall (coder@execulink.com)
''
''  This software is provided 'as-is', without any express or implied
''  warranty.  In no event will the authors be held liable for any damages
''  arising from the use of this software.
''
''  Permission is granted to anyone to use this software for any purpose,
''  including commercial applications, and to alter it and redistribute it
''  freely, subject to the following restrictions:
''
''  1. The origin of this software must not be misrepresented; you must not
''     claim that you wrote the original software. If you use this software
''     in a product, an acknowledgment in the product documentation would be
''     appreciated but is not required.
''  2. Altered source versions must be plainly marked as such, and must not
''     be misrepresented as being the original software.
''  3. This notice may not be removed or altered from any source 
''     distribution.

' -------------------------------------------------------------------
' BASE UI TYPES
' -------------------------------------------------------------------

#ifndef __JM_GUI_BASE_TYPES_DEFINED__
#define __JM_GUI_BASE_TYPES_DEFINED__

Type UI_POINT_T
  x As Integer
  y As Integer
End Type

Type UI_RECT_T
  x As Integer
  y As Integer
  w As Integer
  h As Integer
End Type

Type UI_MSG_DATA_T
  mX As Integer
  mY As Integer
  mW AS Integer
  mB As Integer
  ky As Integer
End Type

Type UI_BOX_PTR As UI_BOX_T Ptr

#define BOXPROC_FUNC_T Function(ByVal this_ As UI_BOX_PTR, ByVal msgid As Integer, ByVal msgdata As UI_MSG_DATA_T Ptr) As Integer

Type DSTR as ubyte ptr

Type UI_BOX_T
  Owner As UI_BOX_PTR
  Prev As UI_BOX_PTR
  Next As UI_BOX_PTR
  Child As UI_BOX_PTR
  BoxProc As BOXPROC_FUNC_T
  DefProc As BOXPROC_FUNC_T

  Id As Integer
  rec As UI_RECT_T
  BoxType As Integer

  Flags As Integer
	Style As Integer
  Caption As DSTR
	DataPtr as Any ptr
	ExtraBytes as integer '' Must be last member!!
End Type

#endif '' __JM_GUI_BASE_TYPES_DEFINED__

#endif '' __INCLUDE_JM_GUI_RT_BI__
